#ifndef PACKET__H
#define PACKET__H

#include "ipaddress.h"
#include "iostream.h"

#define TTL_DEFAULT 15

class Packet {
 public:
  /*   Packet(IPAddress src, IPAddress dst, string payload) {
    payload_ = payload;
    src_ = src;
    dst_ = dst;
    ttl_ = TTL_DEFAULT;
    };*/
  
  Packet(IPAddress src, IPAddress dst, string payload, int size=1024, int ttl=TTL_DEFAULT)
    {
      payload_ = payload;
      src_ = src;
      dst_ = dst;
      tsize_ = size_ = size;
      ttl_ = ttl;
      recordRoute_ = false;
      delay_ = 0;
      delivered_  = false;
    }
  
  void deliver() { delivered_ = true;};
  bool delivered() { return delivered_;}

  int  TTL () { return ttl_; };
  void  setTTL(int ttl) { ttl_ = ttl; };
  int delay() { return delay_; };
  void setDelay(int delay) { delay_=delay; };
  void setRecordRoute(bool recRt) { recordRoute_ = recRt;};
  bool recordRoute() { return recordRoute_; };
  IPAddress src () { return src_; };
  IPAddress dst () { return dst_; };
  void setTsize(int Tsize) { tsize_ = Tsize; };
  int tsize() { return tsize_;};
  int size() { return size_;};
  string payload() { return payload_; };
  void appendPayload(string pl) { payload_ = payload_ + pl;};
 private:
  IPAddress dst_;
  IPAddress src_;
  string payload_;
  int ttl_;
  int delay_;
  int size_;
  int tsize_;
  bool recordRoute_;
  bool delivered_;
};

#endif


